variables:
cache:
  paths:
    - ./gradle
stages:
  - build
  - test
  #- deploy

#JOB Build
# JOB para compilar y empaquetar la api mobile
build:
  image: openjdk:8 # image con variable de entorno
  stage: build
  script:
    - ./gradlew clean build # compilado npm install
  only:
    refs:
      - master
  #except:
    #refs:
      #- master
    #variables: # pendiente
      #- $DISABLE_BUILD == "true" 
      # - $CI_COMMIT_MESSAGE =~ /Merge branch/
  # tags:
  #   - docker #las etiquetas de runner, pero si hay un runner public tambien se puede ejecutar
  # 	Lista de etiquetas que se utilizan para seleccionar Runner.
  cache: # el alamecenamiento,acelerar el tiempo en que se ejecuta un job,
  # reutilizando el mismo contenido del trabajo
    paths:
      - node_modules/ #ruta donde se guarda el cache
# JOB para revision de calidad del codigo
code_quality:
  stage: test
  variables:
    CODECLIMATE_CODE: $CI_PROJECT_DIR
    DOCKER_DRIVER: overlay2
  image: docker:stable
  services:
    - docker:stable-dind
  allow_failure: true
  script:
    - echo "Ejecutando codeclimate"
    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
    - docker run
      --env SOURCE_CODE="$PWD"
      --volume "$PWD":/code
      --volume /var/run/docker.sock:/var/run/docker.sock
      "registry.gitlab.com/gitlab-org/security-products/codequality:$SP_VERSION" /code
  artifacts:
    paths: [gl-code-quality-report.json]
  tags:
    - docker
  only:
    refs:
     - master
  #except:
    #- master
    # - DevOpsLM
  # except:
  #   variables:
  #     - $CODE_QUALITY_DISABLED

# JOB para revision de seguridad del codigo
sast:
  stage: test
  image: docker:stable
  variables:
    SAST_CONFIDENCE_LEVEL: 2
    DOCKER_DRIVER: overlay2
  allow_failure: true
  services:
    - docker:stable-dind
  script:
    # Eliminando el archivo pom.xml para que no inicie sast de maven.
    - rm pom.xml
    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
    - docker run --env SAST_CONFIDENCE_LEVEL="${SAST_CONFIDENCE_LEVEL:-3}"
      --volume "$PWD:/code"
      --volume /var/run/docker.sock:/var/run/docker.sock
      "registry.gitlab.com/gitlab-org/security-products/sast:$SP_VERSION" /app/bin/run /code
  artifacts:
    paths: [gl-sast-report.json]
  tags:
    - docker
  only:
    refs:
     - master
  #except:
    #- master
    # - DevOpsLM
  # except:
  #   variables:
  #     - $SAST_DISABLED
